package ShootOnClickModified
{
  function armor::onTrigger(%this,%obj,%slot,%val)
  {
    if(%obj.getClassName() $= "Player")
    {
      if(%slot == 0)
      {
        if(%val)
        {
          if($Sim::Time<%obj.client.SOCModified_LastFireTime) return;
        }
        %obj.SOCModified_Shoot(%slot,%val);
      }
    }
    return parent::onTrigger(%this,%obj,%slot,%val);
  }
};
activatePackage(ShootOnClickModified);

function repeatedVectorAddwithScale(%vecs)
{
  %vec = "0 0 0";
  %cnt = getFieldCount(%vecs);
  for(%i=0;%i<%cnt;%i++)
  {
    %fld = getField(%vecs,%i);
    %tvec = getWords(%fld,0,3);
    %scale = getWord(%fld,3);
    %svec = vectorScale(%tvec,%scale);
    %vec = vectorAdd(%vec,%svec);
  }
  return %vec;
}

function SimObject::getLeftVector(%obj) { return vectorCross(%obj.getEyeVector(),%obj.getUpVector()); }
function SimObject::getRightVector(%obj) { return vectorScale(%obj.getLeftVector(%obj),-1); }

function Player::SOCModified_Shoot(%obj,%slot,%val)
{
  if(!%val) { cancel(%obj.SOCModified_reShoot); return; }
  if(!isObject(%obj.getObjectMount())) return;
  %mount = %obj.getObjectMount();
  %data = %mount.getDatablock();
  %mountObj = %mount.getMountNodeObject(%data.weaponSlot_RequiredSlot);
  if(%mountObj !$= %obj) return;
  if(%data.shootOnClick)
  {
    if(%mount.weaponSlot_ammo[%mount.weaponSlot_selected] <= 0) return;
    %count = %data.weaponSlot_ProjectileCount[%mount.weaponSlot_selected];
    for(%i=0;%i<%count;%i++)
    {
      %pos = %mount.getPosition();
      %PVec = %data.weaponSlot_Position[(%mount.weaponSlot_selected+1)*10+%i];
      if(%mount.weaponSlot_SwitchSides[%mount.weaponSlot_selected]) {
        if(%mount.weaponSlot_SwitchSides[%mount.weaponSlot_selected] == 1) {
          %PVec = getWord(%PVec,0) SPC getWord(%PVec,1) * -1 SPC getWord(%PVec,2);
          %mount.weaponSlot_SwitchSides[%mount.weaponSlot_selected] = 2; }
        else
          %mount.weaponSlot_SwitchSides[%mount.weaponSlot_selected] = 1; }
      %VVec = %data.weaponSlot_Velocity[%mount.weaponSlot_Selected];
      %iPos = repeatedVectorAddwithScale(%mount.getEyeVector() SPC getWord(%PVec,0) TAB %mount.getLeftVector() SPC getWord(%PVec,1) TAB %mount.getUpVector() SPC getWord(%PVec,2));
      %iVel = repeatedVectorAddwithScale(%mount.getEyeVector() SPC getWord(%VVec,0) TAB %mount.getLeftVector() SPC getWord(%VVec,1) TAB %mount.getUpVector() SPC getWord(%VVec,2));
      %initPos = vectorAdd(%pos,%iPos);
      if(%data.weaponSlot_spread[%mount.weaponSlot_selected]) {
        %iVel = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*%data.weaponSlot_spread[%mount.weaponSlot_selected]) SPC ((getRandom()-0.5)*%data.weaponSlot_spread[%mount.weaponSlot_selected]) SPC ((getRandom()-0.5)*%data.weaponSlot_spread[%mount.weaponSlot_selected])),%iVel); }
      %p = new Projectile()
      {
        dataBlock = %data.weaponSlot_Projectile[%mount.weaponSlot_selected];
        initialPosition = %initPos;
        initialVelocity = %iVel;
        sourceObject = %obj;
        client = %obj.client;
        sourceSlot = %slot;
        scale = "1 1 1";
      };
      if(%data.weaponSlot_MuzzleEffect[%mount.weaponSlot_selected] !$= "")
      {
        %p = new Projectile()
        {
          dataBlock = %data.weaponSlot_MuzzleEffect[%mount.weaponSlot_selected];
          initialPosition = %initPos;
          initialVelocity = %iVel;
          sourceObject = %obj;
          client = %obj.client;
          sourceSlot = %slot;
          scale = "1 1 1";
        };
      }
      MissionCleanup.add(%p);
    }
    %mount.weaponSlot_ammo[%mount.weaponSlot_selected]--;
    cancel(%mount.refillAmmo);
    %mount.refillAmmo = %data.schedule(%data.ammoRefillTick,"refillAmmo",%mount);
    commandToClient(%obj.client,'bottomPrint',"<just:center>\c3" @ %data.weaponSlot_Name[0] @ ": " @ %mount.weaponSlot_ammo[0] @ "/" @ %data.weaponSlot_maxAmmo[0],3,1);
    if(%data.weaponSlot_sound[%mount.weaponSlot_selected] !$= "") serverPlay3d(%data.weaponSlot_sound[%mount.weaponSlot_selected],%pos);
    if(%data.weaponSlot_Hold[%mount.weaponSlot_selected] == 1)
    {
      %obj.SOCModified_reShoot = %obj.schedule(%data.weaponSlot_Delay[%mount.weaponSlot_selected],SOCModified_Shoot,%slot,%val);
    }
    %obj.client.SOCModified_LastFireTime = $Sim::Time + %data.weaponSlot_Delay[%mount.weaponSlot_selected] / 1000;
  }
}
