//########## UH 1 Iroquois

//### Sound

datablock AudioProfile(gc_uh1EngineSound)
{
  filename = "./engine.wav";
  description = AudioDefaultLooping3d;
  preload = true;
};

datablock AudioProfile(gc_MinigunSpinUpSound)
{
  filename = "./minigunspinup.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MinigunFireSound)
{
  filename = "./minigun.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_MinigunSpinDownSound)
{
  filename = "./minigunspindown.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_OverheatSound)
{
  filename = "./overheat.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_bulletBySound)
{
  filename = "./bulletby.wav";
  description = AudioClosestLooping3d;
  preload = true;
};

datablock AudioProfile(gc_bulletHit1Sound)
{
  filename = "./bulletImpact1.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_RocketLoopSound)
{
  filename = "./rocketloop.wav";
  description = AudioCloseLooping3d;
  preload = true;
};

datablock AudioProfile(gc_ExplosionSound)
{
  filename = "./explosion.wav";
  description = AudioDefault3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_OverheatParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 600;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 1;
  spinRandomMin = -5;
  spinRandomMax = 5;
  colors[0] = "1 1 1 0.8";
  colors[1] = "1 1 1 0";
  sizes[0] = 0.2;
  sizes[1] = 0.8;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_OverheatEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 0;
  ejectionVelocity = 1;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_OverheatParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(gc_OverheatMount1Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "Fire";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 2;
  stateEmitter[0] = gc_OverheatEmitter;
  stateEmitterTime[0] = 2;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};
function gc_OverheatMount1Image::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_UH1MinigunFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "./muzzle"; // "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.5 0 1";
  colors[1] = "1 0.8 0.6 1";
  colors[2] = "1 0.5 0 1";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 2;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_UH1MinigunFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 200;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 170;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_UH1MinigunFlashParticle";
};

datablock ParticleData(gc_UH1MinigunSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 800;
  lifetimeVarianceMS = 400;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 1 1 1";
  colors[1] = "0.9 0.9 0.9 0.3";
  colors[2] = "0.8 0.8 0.8 0";
  sizes[0] = 0.5;
  sizes[1] = 1;
  sizes[2] = 3;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_UH1MinigunSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 20;
  velocityVariance = 16;
  ejectionOffset = 0;
  thetaMin = 160;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_UH1MinigunSmokeParticle";
};

datablock ShapeBaseImageData(gc_UH1MinigunFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.03;
  stateEmitter[0] = gc_UH1MinigunFlashEmitter;
  stateEmitterTime[0] = 0.03;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.03;
  stateEmitter[1] = gc_UH1MinigunSmokeEmitter; 
  stateEmitterTime[1] = 0.03;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_UH1MinigunFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_TracerParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/dot";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.9 0.4 0.5";
  colors[2] = "1 0.2 0.1 0.5";
  sizes[0] = 0.2;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_TracerEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_TracerParticle";
};

datablock ParticleData(gc_bulletDebrisExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/chunk";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 0.2;
  sizes[1] = 0.2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_bulletDebrisExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 16;
  velocityVariance = 8;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_bulletDebrisExplosionParticle";
};

datablock ParticleData(gc_bulletExplosionSmokeParticle)
{
  dragCoefficient = 6;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1400;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 1";
  colors[1] = "0.2 0.2 0.2 0.2";
  colors[2] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0.6;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_bulletExplosionSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 8;
  periodVarianceMS = 0;
  ejectionVelocity = 9;
  velocityVariance = 8;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_bulletExplosionSmokeParticle";
};

datablock DebrisData(gc_UH1MinigunDebris)
{
  shapeFile = "";
  lifetime = 0.3;
  minSpinSpeed = -200;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = true;
  fade = true;
  gravModifier = 2;
  emitters = gc_TracerEmitter;
};

datablock ExplosionData(gc_UH1MinigunExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_bulletExplosionSmokeEmitter;
  emitter[1] = gc_bulletDebrisExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
  soundProfile = gc_bulletHit1Sound;
  debris = gc_UH1MinigunDebris;
  debrisNum = 1;
  debrisPhiMin = 0;
  debrisPhiMax = 360;
  debrisThetaMin = 0;
  debrisThetaMax = 45;
  debrisVelocity = 20;
  debrisVelocityVariance = 40;
};

datablock ParticleData(gc_UH1RocketTrailParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.8 0.8 0.8 1";
  colors[1] = "0.8 0.8 0.8 0.5";
  colors[2] = "0.8 0.8 0.8 0";
  sizes[0] = 0.4;
  sizes[1] = 0.8;
  sizes[2] = 2;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_UH1RocketTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 1;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_UH1RocketTrailParticle";
};

datablock ParticleData(gc_UH1RocketExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 16;
  sizes[1] = 12;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_UH1RocketExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_UH1RocketExplosionParticle";
};

datablock ParticleData(gc_UH1RocketSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3500;
  lifetimeVarianceMS = 1500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 6;
  sizes[1] = 12;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_UH1RocketSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 1;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_UH1RocketSmokeParticle";
};

datablock ExplosionData(gc_UH1RocketExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = gc_UH1RocketExplosionEmitter;
  emitter[1] = gc_UH1RocketSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 6;
  lightEndRadius = 0;
  lightStartColor = "1 0.6 0.2";
  lightEndColor = "0 0 0";
  damageRadius = 3;
  radiusDamage = 100;
  impulseRadius = 6;
  impulseForce = 100;
  soundProfile = gc_ExplosionSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 12;
};

//### Projectile

datablock ProjectileData(gc_UH1RocketMuzzleProjectile)
{
  uiName = "";
  projectileShapeName = "";
  explosion = gc_UH1RocketMuzzleExplosion;
  lifetime = 0;
  fadeDelay = 0;
  explodeOnDeath = true;
};

AddDamageType("gc_UH1",'<bitmap:Add-Ons/Vehicle_UH1/CI_uh1>%1','%2<bitmap:Add-Ons/Vehicle_UH1/CI_uh1>%1',1,1);

datablock ProjectileData(gc_UH1MinigunProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 20;
  directDamageType = $DamageType::gc_UH1;
  radiusDamageType = $DamageType::gc_UH1;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 8;
  brickExplosionMaxVolumeFloating = 8;
  impactImpulse = 75;
  explosion = gc_UH1MinigunExplosion;
  particleEmitter = gc_TracerEmitter;
  muzzleVelocity = 150;
  verInheritFactor = 1;
  lifetime = 4000;
  fadeDelay = 4000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  sound = gc_bulletBySound;
};

datablock ProjectileData(gc_UH1RocketProjectile)
{
  uiName = "";
  projectileShapeName = "./rocket.dts";
  directDamage = 0;
  directDamageType = $DamageType::gc_UH1;
  radiusDamageType = $DamageType::gc_UH1;
  brickExplosionRadius = 3;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 50;
  brickExplosionMaxVolumeFloating = 50;
  impactImpulse = 300;
  explosion = gc_UH1RocketExplosion;
  particleEmitter = gc_UH1RocketTrailEmitter;
  muzzleVelocity = 150;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 3500;
  fadeDelay = 3500;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  sound = gc_RocketLoopSound;
  explodeOnDeath = true;
  turningLength = 10;
  turningDelay = 1;
};

//### Turrets

datablock TSShapeConstructor(minigunDts)
{
  baseShape = "./minigun.dts";
  sequence0 = "./minigun_root.dsq root";
  sequence1 = "./minigun_look.dsq look";
  sequence2 = "./minigun_spinup.dsq spinup";
  sequence3 = "./minigun_spin.dsq spin";
  sequence4 = "./minigun_spindown.dsq spindown";
};

datablock PlayerData(gc_UH1MinigunPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./minigun.dts";
  cameraMaxDist = 4;
  cameraTilt = 0;
  cameraVerticalOffset = 1;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = -1.5708;
  maxLookAngle = 1.5708;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 100;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = "1 1 1";
  crouchBoundingBox = "1 1 1";
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
  lookUpLimit = 0.6;
  lookDownLimit = 0.4;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
  useEyePoint = 1;
};

//### Vehicle

datablock FlyingVehicleData(gc_UH1Vehicle)
{
  uiName = "UH-1 Iroquois";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./uh1.dts";
  emap = true;
  minMountDist = 6;
  numMountPoints = 6;
  mountThread[0] = "sit";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  mountThread[3] = "sit";
  mountThread[4] = "sit";
  mountThread[5] = "sit";
  mass = 400;
  maxDamage = 200;
  destroyedLevel = 200;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  lookUpLimit = 0.75;
  lookDownLimit = 0.25;
  jetForce = 500;
  jetEnergyDrain = 8;
  minJetEnergy = 1;
  massCenter = "0 0 0";
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 25;
  softImpactSpeed = 25;
  hardImpactSpeed = 50;
  minRollSpeed = 0;
  maxSteeringAngle = 0.785;
  maxDrag = 40;
  minDrag = 50;
  integration = 4;
  collisionTol = 0.1;
  contactTol = 0.1;
  cameraRoll = false;
  cameraMaxDist = 20;
  cameraLag = 5;
  cameraDecay = 0;
  cameraOffset = 5;
  cameraTilt = 0;
  triggerDustHeight = 3;
  dustHeight = 6;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 0 1";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 0 1";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  splashFreqMod = 300;
  splashVelEpsilon = 0.5;
  exitSplashSoundVelocity = 2;
  softSplashSoundVelocity = 1;
  mediumSplashSoundVelocity = 2;
  hardSplashSoundVelocity = 3;
  rideable = true;
  paintable = true;
  maneuveringForce = 5000;
  horizontalSurfaceForce = 10;
  verticalSurfaceForce = 100;
  autoInputDamping = 0.95;
  steeringForce = 1000;
  steeringRollForce = -1;
  rollForce = 20;
  autoAngularForce = 2000;
  rotationalDrag = 8;
  autoLinearForce = 100;
  maxAutoSpeed = 20;
  hoverHeight = 2.5;
  createHoverHeight = 2;
  minTrailSpeed = 1;
  vertThrustMultiple = 1;
  initialExplosionProjectile = vehicleExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 5000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 5;
  runOverDamageScale = 5;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = false;
  heightcontrol = 1;
  ascendVelocity = 1;
  descendVelocity = -1;
};

datablock FlyingVehicleData(gc_UH1GunshipVehicle : gc_UH1Vehicle)
{
  uiName = "UH-1 Gunship";
  displayName = "";
  shapeFile = "./uh1gunship.dts";
  heightcontrol = 1;
  ascendVelocity = 0.8;
  descendVelocity = -0.8;

  ShootOnClick = 1;
  weaponSlot_RequiredSlot = 0;
  ammoRefillTick = 2000;

  weaponSlot_Hold[0] = 1;
  weaponSlot_Delay[0] = 300;
  weaponSlot_Name[0] = "Rockets";
  weaponSlot_Projectile[0] = gc_UH1RocketProjectile;
  weaponSlot_ProjectileCount[0] = 1;
  weaponSlot_Position[10] = "0.3 -2.3 -0.8";
  weaponSlot_Velocity[0] = "150 0 -5";
  weaponSlot_sound[0] = rocketLauncherFireSound;
  weaponSlot_startingAmmo[0] = "14";
  weaponSlot_maxAmmo[0] = "14";
};

//### Functions

function gc_UH1Vehicle::onadd(%this,%obj)
{
  %obj.playThread(0,"root");
  %obj.PlayAudio(0,gc_uh1EngineSound);
}

function gc_UH1GunshipVehicle::onadd(%this,%obj)
{
  %obj.playThread(0,"root");
  %obj.PlayAudio(0,gc_uh1EngineSound);
  %obj.weaponSlot_ammo[0] = %obj.getDataBlock().weaponSlot_startingAmmo[0];
  %obj.weaponSlot_SwitchSides[0] = 1;
  %obj.weaponSlot_selected = 0;
  %t = new AIPlayer() { dataBlock = gc_UH1MinigunPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,2);
  %obj.turretleft = %t;
  gc_Overheating(%t);
  %t.spin = 0;
  %t = new AIPlayer() { dataBlock = gc_UH1MinigunPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,3);
  %obj.turretright = %t;
  gc_Overheating(%t);
  %t.spin = 0;
}

function gc_UH1GunshipVehicle::onRemove(%this,%obj)
{
  if(isObject(%obj.turretleft)) %obj.turretleft.delete();
  if(isObject(%obj.turretright)) %obj.turretright.delete();
}

function gc_UH1GunshipVehicle::refillAmmo(%data,%this)
{
  cancel(%this.refillAmmo);
  if(!isObject(%this)) return;
  %this.weaponSlot_ammo[0] = mClampF(%this.weaponSlot_ammo[0] + 2,0,%data.weaponSlot_maxAmmo[0]);
  %obj = %this.getMountedObject(0);
  if(isObject(%obj.client))
  {
    commandToClient(%obj.client,'bottomPrint',"<just:center>\c3" @ %data.weaponSlot_Name[0] @ ": " @ %this.weaponSlot_ammo[0] @ "/" @ %data.weaponSlot_maxAmmo[0],3,1);
  }
  if(%this.weaponSlot_ammo[0] < %data.weaponSlot_maxAmmo[0]) %this.refillAmmo = %data.schedule(%data.ammoRefillTick,"refillAmmo",%this);
}

function gc_Overheating(%obj)
{
  if(!isObject(%obj)) return;
  schedule(500,0,gc_Overheating,%obj);
  if(%obj.temp > 0) %obj.temp -= 6;
  if(%obj.temp < 0) %obj.temp = 0;
  if(isObject(%obj.getMountNodeObject(0))) {
  %col = "<color:00ff00>";
  if(%obj.temp > 40) %col = "<color:ffff00>";
  if(%obj.temp > 60) %col = "<color:ff0000>";
  for(%i=0;%i<=(%obj.temp/5);%i++) { %a = %a @ "|"; }
  bottomPrint(%obj.getMountNodeObject(0).client,%col @ "Barrel Temp: " @ %a,2); }
}

package gc_UH1Package
{
  function serverCmdLight(%client)
  {
    if(isObject(%vehicle = %client.player.getObjectMount()))
    {
      if(%vehicle.getDatablock() == gc_UH1GunshipVehicle.getID())
      {
        if(%client.player == %vehicle.getMountNodeObject(0))
        {
          if(%vehicle.weaponSlot_selected == 0)
          {
            %vehicle.weaponSlot_selected = 1;
            return;
          }
          if(%vehicle.weaponSlot_selected == 1)
          {
            %vehicle.weaponSlot_selected = 0;
            return;
          }
        }
      }
    }
    parent::serverCmdLight(%client);
  }
  function armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(%mount.getDataBlock() == gc_UH1MinigunPlayer.getId() && %triggerNum == 0) %obj.gc_UH1MinigunFire(%val,%mount);
      else
        cancel(%obj.gc_UH1MinigunLoop);
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_UH1MinigunFire(%obj,%val,%old)
  {
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_UH1MinigunLoop); return; }
    if(%old !$= %obj.getObjectMount()) { cancel(%obj.gc_UH1MinigunLoop); if(%old.spin > 0) { %old.playThread(2,spindown); %old.spin = 0; %old.playAudio(2,gc_MinigunSpinDownSound); } return; }
    if(!%val)
    {
      if(%obj.getObjectMount().spin > 0)
      {
        %obj.getObjectMount().playThread(2,spindown);
        %obj.getObjectMount().spin = 0;
        %obj.getObjectMount().playAudio(2,gc_MinigunSpinDownSound);
      }
      cancel(%obj.gc_UH1MinigunLoop);
      return;
    }
    if(%obj.getObjectMount().spin == 0)
    {
      %obj.getObjectMount().spin = getSimTime() + 100;
      %obj.getObjectMount().playThread(2,spinup);
      %obj.getObjectMount().playAudio(2,gc_MinigunSpinUpSound);
      %obj.gc_UH1MinigunLoop = %obj.schedule(800,gc_UH1MinigunFire,%val,%obj.getObjectMount());
      return;
    }
    if(%obj.getObjectMount().spin > getSimTime()) return;
    if(%obj.getObjectMount().temp >= 80 & %obj.getObjectMount().overheat == 0)
    {
      serverPlay3D(gc_OverheatSound,%obj.getPosition());
      %obj.getObjectMount().overheat = 1;
      %obj.getObjectMount().mountImage(gc_OverheatMount1Image,1);
      if(%obj.getObjectMount().spin > 0)
      {
        %obj.getObjectMount().playThread(2,spindown);
        %obj.getObjectMount().spin = 0;
        %obj.getObjectMount().playAudio(2,gc_MinigunSpinDownSound);
      }
      cancel(%obj.gc_UH1MinigunLoop);
      return;
    }
    if(%obj.getObjectMount().overheat == 1) {
      if(%obj.getObjectMount().temp >= 60) { cancel(%obj.gc_UH1MinigunLoop); return; }
      else
        { %obj.getObjectMount().overheat = 0; } }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_UH1MinigunProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.01) SPC ((getRandom()-0.5)*0.01) SPC ((getRandom()-0.5)*0.01)),VectorScale(%mount.getMuzzleVector(1),150));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_UH1MinigunFireImage,1);
    %mount.playThread(0,spin);
    %mount.playAudio(2,gc_MinigunFireSound);
    %mount.temp += 2;
    %col = "<color:00ff00>";
    if(%mount.temp > 40) %col = "<color:ffff00>";
    if(%mount.temp > 60) %col = "<color:ff0000>";
    for(%i=0;%i<=(%mount.temp/5);%i++) { %a = %a @ "|"; }
    bottomPrint(%obj.client,%col @ "Barrel Temp: " @ %a,2);
    %obj.gc_UH1MinigunLoop = %obj.schedule(100,gc_UH1MinigunFire,%val,%mount);
    return;
  }
};
activatepackage(gc_UH1Package);
